/**
 * Created by AYMAN on 8/11/2015.
 */

$app.controller('appsCtrl', ['$scope', '$http', function ($scope, $http) {
	$scope.apps = [];
	$scope.pageSize = 50;
	$scope.pageIndex = 1;
	$scope.total = 0;
	$scope.lastUrl = appConfig.lastUrl;
	$scope.env = appConfig.env;

	cache.getItem('_lastSearchedAppName',function(err,data){

		if(data)
			$scope.appName = data;

		$scope.search();
	});
	$scope.logout = function () {
		cache.removeItem('login_emulator', function () {
			window.location = 'login.html' + appConfig.compileQueryString();
		});
	};

	$scope.selectApp = function (app) {

		if (navigator.splashscreen) navigator.splashscreen.show();
		appConfig.mode = $scope.mode ? 1 : 0;
		appConfig.appId = app.appId;
		appConfig.save();
		var url = '../loader.html' + appConfig.compileQueryString() + "&askOfflineMode=" + $scope.askOfflineMode;
		if ($scope.forceUpdate) url += '&forceUpdate=1';

		///use this for offline mode in emulator. If offline then load last selected app
		window.localStorage.setItem("lastSelectedAppLoaderURL",url);

		window.location = url;

	};

	$scope.loadMore = function () {
		$scope.search({pageIndex: $scope.pageIndex + 1});
		return false;
	};

	$scope.search = function (options, callback) {
		$scope.pageIndex = 1;
		if (options) {
			if (options.pageIndex) {
				$scope.pageIndex = options.pageIndex;
			}
		}
		else
			$scope.apps = [];



		cache.getObject('login_emulator', function (err, currentUser) {

			if (!currentUser || !currentUser.userToken || !currentUser.auth) {
				alert('no user logged in');

				debugger;
				cache.removeItem('login_emulator', function () {
					window.location = 'login.html';
				});
				return;
			}

			$scope.searching = true;
			if (!$scope.$$phase) $scope.$apply();

			var config = {
				headers: {
					'auth': currentUser.auth,
					'userToken': currentUser.userToken
				},
				params: {
					name: $scope.appName,
					pageSize: $scope.pageSize,
					pageIndex: $scope.pageIndex
				}
			};

			var url = appConfig.endPoints.updateServer + '/api/user/apps/emulatorApps';
			$http.get(url, config).
			//$http.jsonp(url + "&callback=JSON_CALLBACK").
			success(function (result) {
				if (result) {
					$scope.total = result.total;
					var data = result.data;
					if (data) {
						for (var i = 0; i < data.length; i++) {
							$scope.apps.push(data[i]);
						}
					}

					$scope.showLoadMore = $scope.total > $scope.apps.length;
				}
				$scope.searching = false;
				if (!$scope.$$phase) $scope.$apply();
			}).error(function (data) {
				console.error(data);
				if (callback)
					callback(data, null);

				debugger;
				cache.removeItem('login_emulator', function () {
					window.location = 'login.html';
				});

			});
		});

		cache.setItem('_lastSearchedAppName', $scope.appName);
	};

	$scope.back = function () {
		window.location = $scope.lastUrl;
	};


	window.localStorage.setItem('APP_TYPE', 'emulator');

}]);