/**
 * Created by AYMAN on 8/11/2015.
 */

$app.controller('loginCtrl', ['$scope', '$http', function ($scope, $http) {
	$scope.username = '';
	$scope.password = '';
	$scope.invalidCredentials = false;
	$scope.lastUrl = appConfig.lastUrl;

	$scope.login = function (obj, callback) {
		$scope.invalidCredentials = false;

		var loginData = {email: $scope.email, password: $scope.password};
		if (obj) {
			loginData.email = obj.email;
			loginData.password = obj.password;
		}

		var data = {
			"id": 1, "method": "users/login",
			"params": loginData
		};


		$http.post(appConfig.endPoints.updateServer + '/api/login', {
			email: loginData.email,
			password: loginData.password
		}, {bypassInterceptorForStatus: 404})
			.success(function (result) {
				//set login data in cache for auto login
				cache.setItem('login_emulator', JSON.stringify(result),function(){
					if (callback)
						callback(null, data);

					if (result && result.userToken && result.auth) {
						window.location = 'apps.html' + appConfig.compileQueryString();
					}
				});

			})
			.error(function (data) {
				$scope.invalidCredentials = true;

				console.error(data);
				if (callback)
					callback(data, null);
			});
	};

	cache.getItem('login_emulator', function(err,data){
			if (data) {
				console.log('auto login');

				var userData = JSON.parse(data);

				if (userData && userData.userToken && userData.auth) {
					window.location = 'apps.html' + appConfig.compileQueryString();
			}
			else {
				if (navigator.splashscreen) navigator.splashscreen.hide();

				cache.removeItem('login_emulator');
			}
		}
	});


	var environments=['int','uat','prod'];
	$scope.env = appConfig.env ;


	$scope.changeEnv = function(){
		var i = environments.indexOf(appConfig.env);
		i++;
		if(i <0 || i>= environments.length) i=0;
		$scope.env =appConfig.env = environments[i];
		appConfig.save();

	}



	$scope.back = function(){
		window.location = $scope.lastUrl;
	};

	var isDeviceOnline = function () {
		if (typeof(navigator) != "undefined") {
			if (navigator.connection && navigator.connection.type)
				return navigator.connection.type != "none";
			else if (typeof(navigator.onLine) != "undefined") {
				return navigator.onLine;
			} else {
				return true;
			}
		} else
			return true;
	};




	if(!isDeviceOnline) {
		///use this for offline mode in emulator. If offline then load last selected app
		window.location = window.localStorage.getItem("lastSelectedAppLoaderURL");
		return;
	};



}]);