'use strict';

var environmentConfigs = {
    'int': {
        updateServer: 'http://int2.myapp.buildfire.com'
    },
    'dev': {
        updateServer: 'http://dev.kaleo.com'
    },
    'uat': {
        updateServer: 'http://uat.app.buildfire.com'
    },
    'prod': {
        updateServer: 'http://app.buildfire.com'
    }
};

//getAppId

var appConfig = {
    appId: null
    //, appName: '$appName'
    , _env: 'prod'
    , set env(env) {
        this._env = env;

        this.endPoints = environmentConfigs[this._env];

        if(this._env == 'prod'){
            this.endPoints.updateServer = this.endPoints.updateServer.replace('http:', 'https:')
        }

        if (!this.endPoints) {
            this._env = 'uat';
            this.endPoints = environmentConfigs[this._env];
        }
        this.save();
    }
    , get env() {
        return this._env;
    }
    , mode: 0
    , lastUrl: null
    , forceUpdate: false
    , localStoragePath: (localStorage.getItem('fsPath') || '/') + '/softBundle/'
    , compileQueryString: function () {
        var url = "?appId=" + this.appId
            + "&env=" + this.env
            + "&mode=" + this.mode;

        if (this.lastUrl)url += "&lastUrl=" + encodeURIComponent(this.lastUrl);
        return url;
    }
    , save: function () {
        localStorage.setItem("appConfig", JSON.stringify(this));
    }
    , load: function () {
        var obj = localStorage.getItem("appConfig");
        if (obj) {
            try {
                obj = JSON.parse(obj);
                if (obj.appId)this.appId = obj.appId;
                if (obj.env)this.env = obj.env;
                if (obj.mode)this.mode = obj.mode;

            }
            catch (e) {
                console.error(e);
            }
        }

        var $appId, $env, $mode, $lastUrl, $forceUpdate;

        var getParameterByName = function (name) {
            name = name.replace(/[\[]/, "\\[").replace(/[\]]/, "\\]");
            var regex = new RegExp("[\\?&]" + name + "=([^&#]*)"),
                results = regex.exec(location.search);
            return results === null ? "" : decodeURIComponent(results[1].replace(/\+/g, " "));
        };

        $appId = getParameterByName('appId');
        if ($appId)appConfig.appId = $appId;

        $env = getParameterByName('env');
        if ($env)
            appConfig.env = $env;
        else
            appConfig.env = this._env;

        $forceUpdate = getParameterByName('forceUpdate');
        if($forceUpdate) appConfig.forceUpdate = true;

        appConfig.askOfflineMode = getParameterByName('askOfflineMode') == "true";

        $mode = getParameterByName('mode');
        if ($mode == '1') appConfig.mode = 1;
        else if ($mode == '0') appConfig.mode = 0;

        $lastUrl = getParameterByName('lastUrl');
        if ($lastUrl) appConfig.lastUrl = $lastUrl;


        this.save();

    }

};

appConfig.load();